/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define all routine to manage IP number 	*/
/*	conversion.				*/
/*						*/
/************************************************/
#ifndef BASAFN
#define BASAFN

#include	<netdb.h>

#define AFNFREE (void *(*)(void *))afn_freeipnum

/*No reverse address found marker		*/
#define	NORVERS "No.Reverse"

/*localhost IP number				*/
#define	LOCIP4	"127.0.0.1"
#define	LOCIP6	"::1"

/*IPV6 ipnumber marker				*/
#define STRIPV6 "ipv6:"

#define	AFT sizeof(struct in6_addr)

#define	UKNIP	"?.?.?.?"

#ifdef	AI_ALL
#define HINTFLG	AI_ALL|AI_CANONNAME|AI_CANONIDN
#else /*AI_ALL is not defined in linux <= rh9	*/
#define	HINTFLG	AI_CANONNAME
#endif

typedef	struct	{
	int afntype;	/*IP type		*/
	int afnmask;	/*IP Mask		*/
	u_char ip[AFT];	/*IP number		*/
	}AFNTYP;

extern int afn_ispureip(char *ip);
extern AFNTYP *afn_getaddrinfo(struct addrinfo *rp);
extern AFNTYP *afn_getipnum(char *cleanipstr);
extern AFNTYP *afn_maskip(AFNTYP *afnnum,int cidr);
extern AFNTYP *afn_freeipnum(AFNTYP *afnnum);
extern char *afn_ipnormal(AFNTYP *afnnum);
extern int afn_cmpipnum(AFNTYP *afnnum1,AFNTYP *afnnum2,int mask);
extern char *afn_stripnum(AFNTYP *afnnum);
extern char *afn_stripnummask(AFNTYP *afnnum,int mask);
extern char *afn_reversipnum(AFNTYP *afnnum);
extern const char *afn_reversdom(AFNTYP *afnnum);
extern char *afn_formatip(char *ipnum);
extern char *afn_unformatip(char *ipnum);
#endif
