/************************************************/
/*						*/
/*	Procedure definition to manage MySQL	*/
/*	database.				*/
/*						*/
/************************************************/
#ifndef	BASMYS
#define BASMYS
#include	<time.h>
#include	<stdarg.h>
#include	"subsql.h"

typedef	void MYSQLDM;
typedef	void MYSFILE;
typedef	void MYSRESULT;

#ifdef	with_mysql	/*Only if MYSQL devel	*/
extern int mys_isdaemonup(const char *host,const char *sqlport,const char *dbname,int tentative);
extern MYSFILE *mys_open(const char *host,const char *sqlport,const char *dbname);
extern MYSFILE *mys_close(MYSFILE *mysfile);
extern const char *mys_getdfltport();
extern int mys_action(MYSFILE *ms,char *command);
extern MYSRESULT *mys_tupple(MYSFILE *ms,char *command);
extern int mys_nbrtupple(MYSRESULT *mysresult);
extern char *mys_getvalue(MYSRESULT *mysresult,int row,char *fieldname);
extern char *mys_getfield(MYSRESULT *mysresult,int row,int column);
extern const char *mys_fromunixtime(time_t timestamp);
extern time_t mys_tounixtime(char *date);
extern u_long mys_date(char *strdate);
extern MYSRESULT *mys_dropresult(MYSRESULT *mysresult);
extern int mys_getlock(MYSFILE *ms,LCKTYP **lcklst);
extern int mys_lock(MYSFILE *ms);
extern int mys_unlock(MYSFILE *ms,int commit);
extern u_vlong mys_getseq(MYSFILE *ms,char *sequence);
extern u_vlong mys_incseq(MYSFILE *ms,char *sequence);
extern char *mys_cleanquote(MYSFILE *ms,char *sequence);
extern char *mys_toipbin(MYSFILE *ms,char *ipnum);
#else
#define mys_isdaemonup(a,b,c,d)	nodb_isdaemonup(a,b,c,d)
#define mys_open(a,b,c)		nodb_open(a,b,c)
#define mys_close(a)		nodb_close(a)
#define	mys_getdfltport()	nodb_getdfltport()
#define	mys_action(a,b)		nodb_action(a,b)
#define	mys_tupple(a,b)		nodb_tupple(a,b)
#define	mys_nbrtupple(a)	nodb_nbrtupple(a)
#define mys_getvalue(a,b,c)	nodb_getvalue(a,b,c)
#define mys_getfield(a,b,c)	nodb_getfield(a,b,c)
#define mys_fromunixtime(a)	nodb_fromunixtime(a)
#define mys_tounixtime(a)	nodb_tounixtime(a)
#define mys_date(a)		nodb_date(a)
#define mys_dropresult(a)	nodb_dropresult(a)
#define	mys_getlock(a,b)	nodb_getlock(a,b)
#define	mys_lock(a)		nodb_lock(b)
#define	mys_unlock(a,b)		nodb_unlock(a,b)
#define	mys_getseq(a,b)		nodb_getseq(a,b)
#define	mys_incseq(a,b)		nodb_incseq(a,b)
#define	mys_cleanquote(a,b)	nodb_cleanquote(a,b)
#define	mys_toipbin(a,b)	nodb_toipbin(a,b)
#endif	/*DB_MYSQL		Only if MYSQL devel	*/
#endif
