/************************************************/
/*						*/
/*	Module to define non effective fonction	*/
/*	in case data-base type is called while 	*/
/*	not compiled.				*/
/*						*/
/************************************************/
#ifndef	BASNDB
#define BASNDB
#include	<time.h>
#include	<stdarg.h>
#include	"lowtyp.h"
#include	"subsql.h"

typedef	void NDBFILE;
typedef	void NDBRESULT;

extern int nodb_isdaemonup(const char *host,const char *sqlport,const char *dbname,int tentative);
extern NDBFILE *nodb_open(const char *host,const char *sqlport,const char *dbname);
extern NDBFILE *nodb_close(NDBFILE *ndbfile);
extern const char *nodb_getdfltport();
extern long nodb_action(NDBFILE *ndbfile,char *command);
extern NDBRESULT *nodb_tupple(NDBFILE *ndbfile,char *command);
extern int nodb_nbrtupple(NDBRESULT *ndbresult);
extern NDBRESULT *nodb_dropresult(NDBRESULT *ndbresult);
extern char *nodb_getvalue(NDBRESULT *ndbresult,int row,char *fieldname);
extern char *nodb_getfield(NDBRESULT *ndbresult,int row,int column);
extern char *nodb_fromunixtime(time_t timestamp);
extern time_t nodb_tounixtime(char *date);
extern int nodb_getlock(NDBFILE *ndbfile,LCKTYP **lcklst);
extern int nodb_lock(NDBFILE *ndbfile);
extern int nodb_unlock(NDBFILE *ndbfile,int commit);
extern u_vlong nodb_getseq(NDBFILE *ndbfile,char *sequence);
extern u_vlong nodb_incseq(NDBFILE *ndbfile,char *sequence);
extern char *nodb_cleanquote(NDBFILE *ndbfile,char *sequence);
extern char *nodb_toipbin(NDBFILE *ndbfile,char *ipnum);
#endif
