/************************************************/
/*						*/
/*	Procedure definition to manage PosgreSQL*/
/*	database.				*/
/*						*/
/************************************************/
#ifndef	BASPOS
#define BASPOS
#include	<time.h>
#include	<stdarg.h>
#include	"lowtyp.h"
#include	"subsql.h"

typedef	void POSFILE;
typedef	void POSRESULT;
typedef void POSTMASTER;

#ifdef	with_postgresql /*Only if POSTGRESQL devel	*/
extern int pos_isdaemonup(const char *host,const char *sqlport,const char *dbname,int tentative);
extern POSFILE *pos_open(const char *host,const char *sqlport,const char *dbname);
extern POSFILE *pos_close(POSFILE *posfile);
extern const char *pos_getdfltport();
extern int pos_action(POSFILE *posfile,char *command);
extern POSRESULT *pos_tupple(POSFILE *posfile,char *command);
extern int pos_nbrtupple(POSRESULT *posresult);
extern POSRESULT *pos_dropresult(POSRESULT *posresult);
extern char *pos_getvalue(POSRESULT *posresult,int row,char *fieldname);
extern char *pos_getfield(POSRESULT *posresult,int row,int column);
extern const char *pos_fromunixtime(time_t timestamp);
extern time_t pos_tounixtime(char *date);
extern int pos_getlock(POSFILE *posfile,LCKTYP **lcklst);
extern int pos_lock(POSFILE *posfile);
extern int pos_unlock(POSFILE *posfile,int commit);
extern u_vlong pos_getseq(POSFILE *posfile,char *sequence);
extern u_vlong pos_incseq(POSFILE *posfile,char *sequence);
extern char *pos_cleanquote(POSFILE *posfile,char *sequence);
extern char *pos_toipbin(POSFILE *posfile,char *ipnum);
#else	/*DB_POSTGRESQL Only if POSTGRESQL devel	*/
#define pos_isdaemonup(a,b,c,d)	nodb_isdaemonup(a,b,c,d)
#define pos_open(a,b,c)		nodb_open(a,b,c)
#define pos_close(a)		nodb_close(a)
#define	pos_getdfltport()	nodb_getdfltport()
#define	pos_action(a,b)		nodb_action(a,b)
#define	pos_tupple(a,b)		nodb_tupple(a,b)
#define	pos_nbrtupple(a)	nodb_nbrtupple(a)
#define pos_getvalue(a,b,c)	nodb_getvalue(a,b,c)
#define pos_getfield(a,b,c)	nodb_getfield(a,b,c)
#define pos_fromunixtime(a)	nodb_fromunixtime(a)
#define pos_tounixtime(a)	nodb_tounixtime(a)
#define pos_date(a)		nodb_date(a)
#define pos_dropresult(a)	nodb_dropresult(a)
#define	pos_lock(a)		nodb_lock(a)
#define	pos_getlock(a,b)	nodb_getlock(a,b)
#define	pos_unlock(a,b)		nodb_unlock(a,b)
#define	pos_getseq(a,b)		nodb_getseq(a,b)
#define	pos_incseq(a,b)		nodb_incseq(a,b)
#define	pos_cleanquote(a,b)	nodb_cleanquote(a,b)
#define pos_toipbin(a,b)	nodb_toipbin(a,b);
#endif	/*DB_POSTGRESQL	Only if POSTGRESQL devel	*/
#endif
