/************************************************/
/*						*/
/*	GESBLS:					*/
/*	Take Care of all access to SPAM site	*/
/*	black list.				*/
/*						*/
/************************************************/
#include	<string.h>
#include	<resolv.h> 
#include	<netdb.h> 
#include	<unistd.h> 
#include	<errno.h> 
#include	<malloc.h> 
#include	<syslog.h> 
#include	<sys/stat.h>
#include	<sys/socket.h>
#include	<arpa/inet.h>

#include	"lowtyp.h"
#include	"utlvec.h"
#include	"subclm.h"
#include	"unidns.h"
#include	"gesbls.h"
/*
^L
*/
/************************************************/
/*						*/
/*	Procedure to probe one black list site	*/
/*	and return if there is a status or not	*/
/*						*/
/************************************************/
char *bls_isblsknown(char *blssite,char *reversip)

{
char *blocked;
char **txt;
char dnsquest[300];

blocked=(char *)0;
(void) snprintf(dnsquest,sizeof(dnsquest),"%s.%s",reversip,blssite);
(void) clm_alert(12,"gesbls.c:bls_isblsknown, checking <%s>",dnsquest);
if ((txt=dns_gettxt(dnsquest))!=(char **)0) {
  (void) asprintf(&blocked,"%s -> %s",blssite,txt[0]);
  txt=(char **)vec_freelstlst((void **)txt,VECFREE);
  }
return blocked;
}
/*
^L
*/
/************************************************/
/*						*/
/*	Procedure to probe one black list site	*/
/*	and return if there is a status or not	*/
/*						*/
/************************************************/
char *bls_isonbls(char **blssites,AFNTYP *afnnum)

{
char *blocked;

blocked=(char *)0;
if (blssites!=(char **)0) {
  char *reversip;
  int i;

  reversip=afn_reversipnum(afnnum);
  for (i=0;blssites[i]!=(char *)0;i++) {
    if ((blocked=bls_isblsknown(blssites[i],reversip))!=(char *)0) {
      break;
      }
    }
  (void) free(reversip);
  }
return blocked;
}
