/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define routines to handle clement 	*/
/*	configuration file parsing.		*/
/*						*/
/************************************************/
#ifndef GESCNF
#define GESCNF
#include	<time.h>
#include	<stdio.h>
#include	"unirly.h"
#include	"unidev.h"

/*configuration file keyword			*/
#define	KEEPLOCAL	"keeplocal"

/*mentor application				*/
#define	APPMNT		"mentor"

typedef	struct	{
	int updated;	/*cnf fresh update flag	*/
	time_t update;	/*last update date	*/
	time_t lastscan;/*last config check	*/
	BININF **binds;	/*binds library		*/
	RLYTYP *relais;	/*relais accepted data	*/
	}CNFTYP;

extern CNFTYP *cnf_freeconfig(CNFTYP *cnf);
extern void cnf_dumpconfig(FILE *out,CNFTYP *cnf);
extern void cnf_showcnf(CNFTYP *cnf);
extern BININF **cnf_getbinds(CNFTYP *cnf);
#endif
