/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define module level routines to handle	*/
/*	syntaxic analyze of the E-mail header	*/
/*	part.					*/
/*						*/
/************************************************/
#ifndef GESHDR
#define GESHDR
#include	<time.h>

typedef	enum	{	/*mail originator	*/
	org_smtp,	/*'mail from: '		*/
	org_from,	/*mail from:		*/
	org_sender,	/*mail Sender:		*/
	org_replyto	/*mail Reply-To:	*/
	}ORGENUM;

typedef	struct	{	/*Email header info	*/
	int nbrerror;	/*number of syntax error*/
	time_t cachet;	/*message stamping date	*/
	int nbrreceived;/*num of received header*/
	u_long mtaille;	/*email size.		*/
	ORGENUM org;	/*real from info	*/
	char *realfrom;	/*real E-mail originator*/
	char *msgid;	/*E-mail msgid		*/
	char *subject;	/*E-mail subject line	*/
	char *virname;	/*Virus name if Virus	*/
	char **distlist;/*distribution list	*/
	char **inrplyto;/*MSG Reply-To unique id*/
	char *spamlvl;	/*spam level		*/
	}EVLTYP;

extern EVLTYP *hdr_parseheader(char *session,char **headers);
extern EVLTYP *hdr_freeevl(EVLTYP *evl);
#endif
