/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	GESIPC					*/
/*	Define management level for memory	*/
/*	used to exchange message between 	*/
/*	process.				*/
/*						*/
/************************************************/
#ifndef GESIPC
#define GESIPC
#include	<unistd.h>
#include	<sys/types.h>
#include	"uniipc.h"

#define	ONEWAY	"0:0"	/*one way messages	*/

typedef	void BPTR;

typedef struct	{
	BPTR *bptr;	/*message box		*/
	u_long mntpool;	/*mentor group msg pool	*/
	u_long ckrpool;	/*chcker group msg pool	*/
	}MXCTYP;

extern BPTR *ipc_getbox(u_int mxksize,u_int mxproc);
extern BPTR *ipc_dropbox(BPTR *bptr);
extern void ipc_wakemeup(BPTR *bptr,int onoff);
extern int ipc_subscribe(BPTR *bptr,u_long pool,int onoff);
extern u_long ipc_getpool(BPTR *bptr,pid_t process);
extern u_long ipc_openpool(BPTR *bptr);
extern u_long ipc_closepool(BPTR *bptr,u_long pool);
extern char **ipc_listreply(BPTR *bptr,TIMESPEC *timeout);
extern char *ipc_postmsg(BPTR *bptr,TIMESPEC *timeout,
			 u_long pool,char *msg);
extern char *ipc_getpost(BPTR *bptr,TIMESPEC *timeout,
			 char **msgref,u_long *millisec);
extern u_long ipc_postreply(BPTR *bptr,TIMESPEC *timeout,
			    char *msgref,char *msg);
extern char *ipc_getreply(BPTR *bptr,TIMESPEC *timeout,char *msgref);
extern int ipc_cleanbox(BPTR *bptr,u_int ellapse);
extern u_int ipc_postpending(BPTR *bptr);
extern int ipc_boxready(BPTR *bptr);
extern u_int ipc_mypending(BPTR *bptr);
extern u_int ipc_rmmymsg(BPTR *bptr,TIMESPEC *timeout,char *msgref);
#endif
