/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define routine to manage a TSL 		*/
/*	(uncrypted/crypted) channel.		*/
/*						*/
/************************************************/
#ifndef GESTLS
#define GESTLS
#include	<signal.h>
#include	"utlsoc.h"
#include	"unidev.h"

#define	CRLF	"\r\n"

typedef void TLSFILE;

extern void tls_trace(TLSFILE *tlsfile,int traceon);
extern char **tls_gettraces(TLSFILE *tlsfile);
extern void tls_traceout(TLSFILE *tlsfile,char *comment,char *str,int parnum);
extern int tls_waitforchar(TLSFILE *tlsfile,u_long microsec,const sigset_t *st);
extern int tls_isready(TLSFILE *tlsfile);
extern int tls_checkfeed(TLSFILE *tlsfile,u_long usec,const sigset_t *mysigset);
extern int tls_write(TLSFILE *tls,char *buffer,int parnum);
extern TLSFILE *tls_accept(LSTTYP *lst);
extern int tls_gotls(TLSFILE *tls,int accepting);
extern int tls_intls(TLSFILE *tls);
extern char *tls_getcipher(TLSFILE *tls);
extern int tls_close(TLSFILE *tls);
extern int tls_printf(TLSFILE *tls,const char *fmt,...);
extern int tls_fpurge(TLSFILE *tls);
extern char *tls_fgets(char *s,int size,TLSFILE *tlsfile);
extern char *tls_getbigline(TLSFILE *tlsfile);
extern char *tls_getaddrname(TLSFILE *tlsfile,PEERTYP peer,char *unknown);
extern TLSFILE *tls_opentcp(char *addrname,char *port,int swait,int *socker);
extern char *tls_waitforaction(TLSFILE *tls,u_int secwait);
extern int tls_iseof(TLSFILE *tlsfile);
extern u_long tls_idle(TLSFILE *tlsfile);
extern int tls_getreply(TLSFILE *tls,u_int mxwait,PROTYP proto,char **reply);
extern int tls_waitsignon(TLSFILE *tls,u_int mxwait,PROTYP proto,char **reply);
#endif
