/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define module level routines to handle	*/
/*	syntaxic analyze of the Trusted data	*/
/*	Stream.					*/
/*						*/
/************************************************/
#ifndef GESTRU
#define GESTRU

/*Trust stream message exchange keyword		*/
#define	STRBAN	"Banned"
#define	STRTRS	"Trusted"
#define	STRSTD	"Standard"	
#define	STRSTA	"Status"	
#define	STRFRM	"From"	

typedef struct dlg DLGTYP;

struct 	dlg	 {	/*forwarded data	*/
	char *orig;	/*Flag status origin	*/
	time_t flgt;	/*Flagged time		*/
	int flgdata;	/*struct data/fwrd flag	*/
	union {
	  DLGTYP **frw;	/*forwarded data	*/
	  int status;	/*data status		*/
	  }frwdata;
	};

typedef struct	 {	/*BAN/TRUSTED streams	*/
	char *ip;	/*IP 			*/
	int mask;	/*IP mask value		*/
	DLGTYP **data;	/*status data related	*/
	}STRMTY;

typedef	struct	{
	char *peername;	/*streams name origin	*/
	char *peerip;	/*streams ip origin	*/
	STRMTY	**strms;/*list of streams	*/
	}TRUTYP;	

extern TRUTYP *tru_parsetrust(char *peername,char *peerip,char **trustlst);
extern DLGTYP *tru_freedlg(DLGTYP *dlg);
extern DLGTYP *tru_dupdlg(DLGTYP *dlg);
extern DLGTYP **tru_locdlg(STRMTY *strm,DLGTYP *dlg);
extern STRMTY *tru_dupstrm(STRMTY *strm);
extern STRMTY *tru_freestrm(STRMTY *strm);
extern TRUTYP *tru_freetrusts(TRUTYP *dattrusts);
extern char **tru_dumpdlgs(DLGTYP **dlgs,int tab);
extern char **tru_dumpstrm(char *myname,char *myip,STRMTY *strm);
extern void tru_setorigin(TRUTYP *dattrusts);
#endif
