/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	GESSBL:					*/
/*	Routine to check remote server SBL	*/
/*	status.					*/
/*						*/
/************************************************/
#
#include	"lowtyp.h"
#include	"utlvec.h"
#include	"basafn.h"
#include	"subclm.h"
#include	"gesbls.h"
#include	"gesdbc.h"
#include	"lvlbls.h"
/*

*/
/************************************************/
/*						*/
/*	To check if recipient want to check	*/
/*	SBL status against originator IP	*/
/*	Return an allocated string with the	*/
/*	status error.				*/
/*						*/
/************************************************/
char *bls_isblslisted(SQLFILE *sql,char *peerip,int sblid)


{
#define	OPBL	"lvlbls.c:bls_isblslisted,"

char *note;
AFNTYP *afnnum;
char **blssites;
int phase;
int proceed;

note=(char *)0;
afnnum=(AFNTYP *)0;
blssites=(char **)0;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case 0	:	/*do we have an ipnum	*/
      if ((afnnum=afn_getipnum(peerip))==(AFNTYP *)0) {
	(void) clm_alert(0,"%s unanble to getipnum for <%s> (bug?)",OPBL,peerip);
 	proceed=false;	/*no need to go further	*/	
	}
      break;
    case 1	:	/*check if sbllst avail	*/
      if ((blssites=dbc_getblssites(sql,sblid,afnnum->afntype))==(char **)0)
 	phase=999;	/*no need to go further	*/	
      break;
    case 2	:	/*check if within list	*/
      note=bls_isonbls(blssites,afnnum);
      break;
    case 3	:	/*free memory used	*/
      blssites=(char **)vec_freelstlst((void *)blssites,VECFREE);
      break;
    default	:	/*SAFE guard		*/
      afnnum=afn_freeipnum(afnnum);
      proceed=false;
      break;
    }
  phase++;
  }
return note;
}
