/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define sub level procedure needed by	*/
/*	clement.				*/
/*						*/
/************************************************/
#ifndef SUBCLM
#define SUBCLM
#include	<unistd.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	"vers.h"
#include	"lowtyp.h"
#include	"utlgac.h"
#include	"clmdst.h"

/*Mentor CLiEnt MENTor application name		*/
#define CLEMENT "clement"
#define	CLMPOOL	25	/*msg exchange main hook*/

/*to call the Email delivery shell script	*/
#define	SHELL	"shell"
#define	DELIVER	"deliver.sh"
/*to call the Email trouble report shell script	*/
#define	TROUBLE	"trouble.sh"

/*transit subdirectory name			*/
#define	TSUFFIX	"-S"

/*defining application directory		*/
typedef	enum	{
	d_tmp,		/*directory /tmp	*/
	d_crash,	/*the crash directory	*/
	d_tls,		/*certificat directory	*/
	d_etc,		/*directory is /etc	*/
	d_syscnf,	/*dir is /etc/sysconfig	*/
	d_cnf,		/*clement config dir	*/
	d_spool,	/*spool directory	*/
	d_queue,	/*queue spool directory	*/
	d_mails,	/*E-mail keeplocal mode	*/
	d_tests,	/*application tests area*/
	d_dbgs,		/*debug directory	*/
	d_bin,		/*directory /usr/bin	*/
	d_sbin,		/*directory /usr/sbin	*/
	d_log,		/*logs directory 	*/
	d_lock,		/*locking directory	*/
	d_trblq,	/*trouble last directory*/
	d_transit,	/*going out directory	*/
	d_tobesend,	/*smtpout debug sequence*/
	d_usrlib,	/*directory /usr/lib	*/
	d_varlib,	/*directory /var/lib	*/
	d_null		/*no directoy specified	*/
	}DIRENUM;

typedef	struct	{	/*vocable table type	*/
	int code;	/*code value		*/
	const char *key;/*key code		*/
	const void *ptr;/*pay load		*/
	}VOCTYP;

/*Signal flag definition			*/
extern 	int sigterm;
extern 	int sigquit;
extern 	int sigint;

/*application working base directory		*/
extern char *base;
/*application name				*/
extern char *appname;
/*application working mode foreground/background*/
extern int clm_foreground;

/*application received a SIGABRT signal		*/
extern int gotsigabrt;

extern int clm_isdir(char *dirpath);
extern char *clm_astrcat(char *src,char *ext);
extern int clm_fasprintf(char **dst,char *fmt,...);
extern void clm_cutchar(char *str,char cut);
extern char *clm_freestr(char *str);
extern char *clm_getvers();
extern u_long clm_getmillisec();
extern char *clm_uniquename(unsigned int seq);
extern char **clm_splitstring(char *msg,unsigned char cut);
extern char *clm_mergestring(char **lst,unsigned char merge);
extern u_long clm_date(time_t curtime);
extern char *clm_ascsystime(time_t curtime);
extern char *clm_ascsysdate(time_t curtime);
extern char *clm_ascsysdatetime(time_t curtime);
extern char *clm_ascsysstamp(time_t curtime);
extern time_t clm_datetimesysasc(char *strdate,char *strtime);
extern void clm_alert(const int dlevel,const char *fmt,...);
extern void clm_argvtrace(const int dlevel,const char *fmt,char *argv[]);
extern char *clm_mkbase(char *newbase);
extern const char *clm_appdir(DIRENUM dir);
extern VOCTYP *clm_getvoca(const VOCTYP *table,char *str);
extern void clm_trapsegv(int onoff);
extern void clm_core_dump(char *frmt, ...);
extern void clm_settrap(int set);
extern char *clm_strtolower(char *str);
extern char *clm_getstr(FILE *fichier,char *str,u_int taille,char carcom);
extern int clm_createdirs(char *dirname,int mode);
extern int clm_appenfile(FILE *fin,char *filename,int maxcount);
extern int clm_dupfile(char *original,char *copy);
extern void clm_chgid(char *appnom,DIRENUM dir);
extern void clm_backfullid();
extern void clm_loadsysconf(char *appnom,int toadd);
extern void clm_loadconf(char *appnom);
extern int clm_isnewfile(char *filename,time_t tempo);
extern char *clm_getapvers();
extern char *clm_skipblank(char *string);
extern char *clm_skiprtlf(char *string);
extern char *clm_cleanstring(char *string);
extern char **clm_addfrmstr(char **strlst,const char *fmt,...);
extern int clm_timeslice(TIMESPEC *timeout);
extern void clm_pushdebug(int newdebug);
extern void clm_popdebug();
extern void clm_trashmem(int tgtdbg,GACTYP *gac);
#endif
