/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define all routine to manage email	*/
/*	transit queue.				*/
/*						*/
/************************************************/
#ifndef UNIQUE
#define UNIQUE
#include	"subclm.h"

/*to deliver an Email locally			*/
#define	LOCALDEL	"Local_delivery"
#define	LOCALQUAR	"Local_quarantine"

/*define Queue status				*/
#define	QWAIT	0	/*queue to be send	*/
#define QPROG	1	/*queue send in progress*/
#define QTRBL	2	/*queue in trouble	*/
#define	QDEL	3	/*queue delete (debug)	*/

/*Email type definition				*/
typedef	enum		{
	mm_std,		/*Standard Email	*/
	mm_warn,	/*Email warning		*/
	mm_rebounce,	/*Email rebounce	*/
	mm_lasthope,	/*Email last chance	*/
	mm_unknown	/*big big trouble	*/
	}MMOENU;

/*struct to manage transit queue		*/
typedef struct		{
	char *session;	/*session unique ID	*/
	u_long transit;	/*Transit unique number	*/
	u_long numtrace;/*trace file ID		*/
	char *outip;	/*IP used to send Email	*/
	char *smtpmx;	/*server to send Email	*/
	char *smtpport;	/*port to post the Email*/
	char *rmtsrvr;	/*remote server used	*/
	char *subject;	/*email subject		*/
	char *rejectto;	/*where to send error	*/
	char *orgeml;	/*originator full email	*/
	char *recname;	/*recipient email name	*/
	char *recdom;	/*recipient email domain*/
	int status;	/*transaction status	*/
	char *why;	/*status explaination	*/
	MMOENU mode;	/*mail mode		*/
	int retry;	/*number of retry	*/
	int progress;	/*progress status	*/
			/*0 pending		*/
			/*1 in progress		*/
			/*2 trouble queue	*/
	time_t start;	/*transit start		*/
	time_t lasttime;/*last status time stamp*/
	time_t nexttime;/*next retry date/time	*/
	time_t upto;	/*trying to send upto	*/
	int orgstatus;	/*inqueue post status	*/
	int grpin;	/*transaction group	*/
	int lang;	/*language report to use*/
	char **logs;	/*queue report logs	*/
	}QUETYP;

extern u_long que_getuniqtransit();
extern void que_dbgqueuedump(QUETYP *queue,const char *mrkr,int num);
extern char *que_tracename(QUETYP *queue);
extern char *que_getdatafilename(DIRENUM dir,QUETYP *queue);
extern char *que_getreportsubject(QUETYP *queue,int warning);
extern char **que_getreportdata(QUETYP *queue,int warning);
extern QUETYP *que_mkqueue(char *outip,char *smtpmx,char *smtpport,char *session,int transit,char *subject,
			   char *rejectto,char *orgeml,int grpin,char *recname,char *recdom,MMOENU mode,int orgstatus);
extern QUETYP *que_freequeue(QUETYP *queue);
extern QUETYP **que_freequeues(QUETYP **queues);
extern QUETYP *que_dupqueue(QUETYP *queue);
extern QUETYP **que_dupqueues(QUETYP **queues);
#endif
