/************************************************/
/*						*/
/*	Procedure definition to manage a SQL	*/
/*	database.				*/
/*						*/
/************************************************/
#ifndef	UNISQL
#define UNISQL
#include	<stdlib.h>
#include	<time.h>
#include	"lowtyp.h"
#include	"subsql.h"
#include	"subclm.h"

/*ENV variable to get the Mentor DB type	*/
#define	CLEMENT_DB_TYPE	"DB_TYPE"

/*default data-base name and port		*/
#define	SQLDBNAME	"clement"

/*data-base name                                */
#define POSTGRESQL	"POSTGRESQL"
#define MYSQL		"MYSQL"

typedef void SQLDAEMON;	/*Daemon process data	*/
typedef	void SQLFILE;
typedef void SQLRESULT;

extern const char *sql_getdbhost(const char *dbhost);
extern const char *sql_getdbport(const char *dbport);
extern const char *sql_getdbname(const char *dbname);
extern char *sql_setdbstr(SQLFILE *sqlfile,char *str);
extern int sql_isdaemonup(const char *dbhost,const char *dbport,const char *dbname);
extern SQLFILE *sql_open(const char *dbhost,const char *dbport,const char *dbname);
extern SQLFILE *sql_close(SQLFILE *sqlfile);
extern int sql_getlock(SQLFILE *sqlfile,LCKTYP **lcklst);
extern int sql_lock_action(SQLFILE *sqlfile);
extern int sql_unlock_commit(SQLFILE *sqlfile);
extern int sql_unlock_rollback(SQLFILE *sqlfile);
extern int sql_action(SQLFILE *sqlfile,char const *fmt,...);
extern SQLRESULT *sql_tupple(SQLFILE *sqlfile,const char *fmt,...);
extern int sql_nbrtupple(SQLFILE *sqlfile,SQLRESULT *sqlresult);
extern void sql_dropresult(SQLFILE *sqlfile,SQLRESULT *sqlresult);
extern char *sql_getvalue(SQLFILE *sqlfile,SQLRESULT *sqlresult,
			  int row,char *fieldname);
extern char *sql_getfield(SQLFILE *sqlfile,SQLRESULT *sqlresult,
			  int row,int column);
extern const char *sql_fromunixtime(SQLFILE *sqlfile,time_t timestamp);
extern time_t sql_tounixtime(SQLFILE *sqlfile,char *date);
extern u_long sql_date(SQLFILE *sqlfile,char *strdate);
extern char *sql_strdup(const char *dbstr);
extern long sql_atol(char *dbstr);
extern char *sql_cleanstr(SQLFILE *sqlfile,char *str);
extern u_vlong sql_getseq(SQLFILE *sqlfile,char *seqname);
extern u_vlong sql_incseq(SQLFILE *sqlfile,char *seqname);
extern char *sql_toipbin(SQLFILE *sqlfile,char *ipnum);
#endif
