/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the LICENCE file in this	*/
/*	package.				*/
/*						*/
/*	Define low level UTiLity routine to do a*/
/*	flexible memory garbage collector.	*/
/*						*/
/************************************************/
#ifndef UTLGAC
#define UTLGAC
#include	<stdlib.h>
#include	<stdarg.h>

typedef	void GACTYP;

extern const char *gac_getversion();
extern void gac_setcurbase(int *debug,int *verbose,char *path);
extern void gac_setlogdir(const char *path);
extern int gac_getusedmemorysize();

extern GACTYP *gac_open(int tgtdbg,const char *apname,const char *extension);
extern int gac_close(GACTYP *gac);
extern int gac_trash(int tgtdbg,GACTYP *gac);
extern int gac_start(GACTYP *gac);
extern int gac_stop(GACTYP *gac);

/*routine we do NOT want to the glibc one 	*/
/*Primary memory function			*/
extern void *malloc(size_t size);
extern void *realloc(void *ptr,size_t size);
extern void free(void *ptr);
extern void *memaligne(size_t alignement,size_t size);
extern void *calloc(size_t nmemb, size_t size);

/*Secondary memory function			*/
extern int putenv(char *valeur);
extern int setenv(const char *name,const char *value,int overwrite);
extern int unsetenv(const char *name);
extern int vasprintf(char **strp, const char *fmt,va_list args);
extern int asprintf(char **strp, const char *fmt, ...);
extern char *strdup(const char *str);
extern char *strndup(const char *str,size_t n);
#endif
