/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define utility level procedure to handle*/
/*	process function.			*/
/*						*/
/************************************************/
#ifndef UTLPRC
#define UTLPRC
#include	<stdlib.h>
#include	<stdarg.h>

/*Signal to be send to check if a process is	*/
/*still up and running				*/
#define SIGCHECK	0

typedef	struct	{
	u_int nbr;	/*nbr process in queue	*/
	pid_t *pqueue;	/*process queue		*/
	}PRCTYP;

extern void prc_allow_core_dump();
extern void prc_core_dump(const char *crashdir,const char *fmt,va_list args);
extern int prc_checkprocess(pid_t pid);
extern void prc_nozombie();
extern PRCTYP *prc_freeprc(PRCTYP *prclst);
extern PRCTYP *prc_addtoprc(PRCTYP *prclst,pid_t pid);
extern PRCTYP *prc_childkill(PRCTYP *prclst,int delay);
extern PRCTYP *prc_childcheck(PRCTYP *prclst);
extern void prc_setpace(unsigned long millisec,int onoff);
#endif
