/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define utility level procedure to handle*/
/*	low level socket function		*/
/*						*/
/************************************************/
#ifndef UTLSOC
#define UTLSOC

#include	<sys/socket.h>
#include	<arpa/inet.h>

typedef enum {pr_locname,pr_locip,pr_remname,pr_remip}PEERTYP;

extern char *soc_getaddrname(int handle,PEERTYP peer,char *unknown);

#if defined(DIST_rh73)	|| \
    defined(DIST_rh80)	|| \
    defined(DIST_rh9)	|| \
    defined(DIST_rhel3)	|| \
    defined(DIST_rhel4)	|| \
    defined(DIST_fc2)	|| \
    defined(DIST_fc3)	|| \
    defined(DIST_fc4)	|| \
    defined(DIST_el46)	|| \
    defined(DIST_el47)	|| \
    defined(other_os_are_fine)

/*subroutine ppol NOT available in distribution	*/
#define	NEED_PPOLL

#include	<signal.h>
#include	<poll.h>

extern int ppoll(struct pollfd *fds, nfds_t nfds,const struct timespec *timeout,
	  	 const sigset_t *set);
#endif

#endif
