/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define utility level procedure to manage*/
/*	dynamic memory list			*/
/*						*/
/************************************************/
#ifndef UTLVEC
#define UTLVEC
#include	<stdlib.h>

#define	VECFREE	(void *(*)(void *))free


/*Vector list definition 			*/
/*Doubly-circularly-linked lists		*/
typedef struct LIST VECLST;
typedef struct LIST {
	void *payload;	/*payload		*/
	VECLST *prv;	/*previous node		*/
	VECLST *nxt;	/*next node		*/
	}VECTOR;

typedef	struct		{
	u_int numvec;	/*number of vector	*/
	VECLST *vcl;	/*vector list		*/
	}VPTR;

extern VPTR *vec_addveclst(VPTR *vptr,void *payload);
extern int vec_rmveclst(VPTR **vptr,void *payload);
extern VPTR *vec_freeveclst(VPTR *vptr,void *(*freepayload)(void *));
extern unsigned int vec_sizelstlst(void **lptr);
extern void **vec_addlstlst(void **lptr,void *payload);
extern void **vec_mrglstlst(void **lptr,void **ltoadd);
extern int vec_rmlstlst(void **lptr,void *payload);
extern void **vec_freelstlst(void **lptr,void *(*freepayload)(void *));
#endif
